#include<stdio.h>
#include<stdlib.h>
#include<pthread.h>

void merror(const char *s, int i){
 printf("%s:%d\n",s,i);
 exit(-1);
}

struct thid{
 int priv;
 int * shrd;
} typedef thid_t;

void *ploop(void *arg){
 thid_t *i = (thid_t *) arg;
 pthread_t pid = pthread_self();
 pthread_t pnew;
 thid_t *id  =(thid_t *) malloc (sizeof(thid_t));
 
 id->priv=i->priv+1;
 id->shrd=i->shrd;

 pthread_create(&pnew,NULL,ploop,id);
 while(1) 
  printf("I'm thread rank: (private) %d-- (shrared)%d -- self%d\n", i->priv,*(i->shrd), pid);
}

int main(int argc, char **argv){
 int i, n;
 thid_t *id;
 pthread_t *pt;


 sscanf(argv[1],"%d",&n);

 pt = (pthread_t *) malloc (n*sizeof(pthread_t));
 id = (thid_t *) malloc (n*sizeof(thid_t));

 for (i=0;i<n;i++){
  int status;
  id[i].priv = i;
  id[i].shrd=&i;
  printf("Trying to create %d\n",id[i].priv);
  status= pthread_create(pt+i,NULL,&ploop,id+i);
  if (status !=0)
   merror("Thread Creation Error",status);
 }


 sleep(40);

 exit(0);

}

