#include<unistd.h>
#include<errno.h>
#include<stdio.h>
#include<stdlib.h>
/* #define _REENTRANT */    /* basic 3-lines for threads */
#include <pthread.h>
/* #include <thread.h>  */
#include<time.h>


void err_abort(const int i){
 printf("%d:%s\n",i,strerror(errno));
 exit(-1);
}

int total, loopmax;

int val = 0;

typedef 
 struct channel{
   pthread_mutex_t *cin, *cout;
   int val;
   pthread_t pid;
 } channel_t;

void * from(void *arg){
 channel_t *ch = (channel_t *) arg;
 for (;;){
printf("fr to lock in\n");
  pthread_mutex_lock(ch->cin);
printf("fr locked in\n");
  ch->val++;
printf("fr to unlock out\n");
  pthread_mutex_unlock(ch->cout);
printf("fr unlocked out\n");
 }
}
 
channel_t * from_create(int n){
 channel_t *ch = (channel_t *) malloc(sizeof(channel_t));
 ch->cin=(pthread_mutex_t *) malloc(sizeof(pthread_mutex_t));
 ch->cout=(pthread_mutex_t *) malloc(sizeof(pthread_mutex_t));
 pthread_mutex_init(ch->cin,NULL);
 pthread_mutex_init(ch->cout,NULL);
 ch->val = n;

 pthread_mutex_lock(ch->cout);

 if (pthread_create(&ch->pid,NULL,&from,&n) !=0)
  exit(-1);
 
 return ch;

}

int take(channel_t *ch){
 int v;
printf("tk to lock out\n");
 pthread_mutex_lock(ch->cout);
 v = ch->val;
 pthread_mutex_unlock(ch->cin);
printf("tk unlocked in\n");

 return v;
}


int main(int argc, char **argv){
 int i,init,n;
 channel_t *ch;
 pthread_mutex_t m;

 sscanf(argv[1],"%d",&init);
 sscanf(argv[2],"%d",&n);

 pthread_mutex_init(&m,NULL);
/*  ch = from_create(init); */
 for (i=0;i<n;i++){
/*   int v = take(ch); */
  int v;
  pthread_mutex_lock(&m);
  v=ch->val++;
  pthread_mutex_unlock(&m);
  printf("v:%d\n",v);
  printf("%d\n",pthread_self());
 }
 

 exit(0);

}


