#include<stdio.h>
#include<stdlib.h>
#include<unistd.h>
#include<sys/wait.h>
#include<sys/time.h>

void merror(const char *s, int i){
 printf("%s:%d\n",s,i);
 exit(-1);
}

int total, loopmax;
int id;
pid_t master;

void proc(void){
 int j;
 int status;
 int ci;

 if (id<total){
  ci =fork();
  if (ci == 0){
   id++;
   proc();
/*   while (waitpid((pid_t) -1,NULL,WNOHANG)); */
/*   if (getpid()!=master)    exit(0);  */
  }
 }
 for (j=0;j<loopmax;j++)
   printf("my id:%d\n",id);
 while (waitpid((pid_t) -1,NULL,WNOHANG)!=-1);
 if (getpid()!=master)    exit(0); 

 
}

 

int main(int argc, char **argv){
 struct timeval t0,t1;
 struct timezone tz0,tz1;
 int status;

 master=getpid();

 sscanf(argv[1],"%d",&total);
 sscanf(argv[2],"%d",&loopmax);

 gettimeofday(&t0,&tz0);
 proc();
 while (waitpid((pid_t) -1,NULL,WNOHANG)!=-1);
 gettimeofday(&t1,&tz1);

 sleep(2);

 printf("Total time:%ld:%ld:%ld\n",
           (long) t0.tv_sec*1000000+t0.tv_usec,
           (long) t1.tv_sec*1000000+t1.tv_usec,
           ((long) t1.tv_sec*1000000+t1.tv_usec)-
           ((long) t0.tv_sec*1000000+t0.tv_usec));

 exit(0);

}

